; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;			(adr_GRAFIC_X1_L)													
;			(adr_GRAFIC_X1_H)													
;			(adr_GRAFIC_Y1_L)													
;			(adr_GRAFIC_Y1_H)													
;			(adr_GRAFIC_X2_L)													
;			(adr_GRAFIC_X2_H)													
;			(adr_GRAFIC_Y2_L)													
;			(adr_GRAFIC_Y2_H)													
;																				
;																				
; Zeichnet ein Rechteck an den KOORDINATEN (X1,Y1) (X2,Y2)						
;																				
GRAFIC_RECHTECK:
	; SICHERUNGSKOPIE						
	LDS XL,(adr_GRAFIC_X1_L)
	LDS XH,(adr_GRAFIC_X1_H)
	LDS YL,(adr_GRAFIC_Y1_L)
	LDS YH,(adr_GRAFIC_Y1_H)
	STS(adr_GRAFIC_X1_KOPIE_L),XL
	STS(adr_GRAFIC_X1_KOPIE_H),XH
	STS(adr_GRAFIC_Y1_KOPIE_L),YL
	STS(adr_GRAFIC_Y1_KOPIE_H),YH
	LDS XL,(adr_GRAFIC_X2_L)
	LDS XH,(adr_GRAFIC_X2_H)
	LDS YL,(adr_GRAFIC_Y2_L)
	LDS YH,(adr_GRAFIC_Y2_H)
	STS(adr_GRAFIC_X2_KOPIE_L),XL
	STS(adr_GRAFIC_X2_KOPIE_H),XH
	STS(adr_GRAFIC_Y2_KOPIE_L),YL
	STS(adr_GRAFIC_Y2_KOPIE_H),YH
	; vertical-links (X1/Y1)(X1/Y2)			
	LDS temp1,(adr_GRAFIC_X1_KOPIE_L)		; X1 (temp1+2)	
	LDS temp2,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp3,(adr_GRAFIC_Y1_KOPIE_L)		; Y1 (temp3+4)	
	LDS temp4,(adr_GRAFIC_Y1_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y2_KOPIE_L)		; Y2 (temp7+8)	
	LDS temp8,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp1	; X1		
	STS(adr_GRAFIC_X1_H),temp2
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp1	; X2		
	STS(adr_GRAFIC_X2_H),temp2
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE	
	; horizontal-unten (X1/Y1)(X2/Y1)		
	LDS temp1,(adr_GRAFIC_X1_KOPIE_L)		; X1 (temp1+2)	
	LDS temp2,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp3,(adr_GRAFIC_Y1_KOPIE_L)		; Y1 (temp3+4)	
	LDS temp4,(adr_GRAFIC_Y1_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X2_KOPIE_L)		; X2 (temp5+6)	
	LDS temp6,(adr_GRAFIC_X2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp1	; X1		
	STS(adr_GRAFIC_X1_H),temp2
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp5	; X2		
	STS(adr_GRAFIC_X2_H),temp6
	STS(adr_GRAFIC_Y2_L),temp3	; Y2		
	STS(adr_GRAFIC_Y2_H),temp4
	rcall GRAFIC_LINIE	
	; vertikal-rechts (X2/Y1)(X2/Y2)
	LDS temp3,(adr_GRAFIC_Y1_KOPIE_L)		; Y1 (temp3+4)	
	LDS temp4,(adr_GRAFIC_Y1_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X2_KOPIE_L)		; X2 (temp5+6)	
	LDS temp6,(adr_GRAFIC_X2_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y2_KOPIE_L)		; Y2 (temp7+8)	
	LDS temp8,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp5	; X1		
	STS(adr_GRAFIC_X1_H),temp6
	STS(adr_GRAFIC_Y1_L),temp3	; Y1		
	STS(adr_GRAFIC_Y1_H),temp4
	STS(adr_GRAFIC_X2_L),temp5	; X2		
	STS(adr_GRAFIC_X2_H),temp6
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE	
	; horizontal-oben (X2/Y2)(X1/Y2)
	LDS temp1,(adr_GRAFIC_X1_KOPIE_L)		; X1 (temp1+2)	
	LDS temp2,(adr_GRAFIC_X1_KOPIE_H)
	LDS temp5,(adr_GRAFIC_X2_KOPIE_L)		; X2 (temp5+6)	
	LDS temp6,(adr_GRAFIC_X2_KOPIE_H)
	LDS temp7,(adr_GRAFIC_Y2_KOPIE_L)		; Y2 (temp7+8)	
	LDS temp8,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X1_L),temp5	; X1		
	STS(adr_GRAFIC_X1_H),temp6
	STS(adr_GRAFIC_Y1_L),temp7	; Y1		
	STS(adr_GRAFIC_Y1_H),temp8
	STS(adr_GRAFIC_X2_L),temp1	; X2		
	STS(adr_GRAFIC_X2_H),temp2
	STS(adr_GRAFIC_Y2_L),temp7	; Y2		
	STS(adr_GRAFIC_Y2_H),temp8
	rcall GRAFIC_LINIE	
	; wieder herstellen			
	LDS XL,(adr_GRAFIC_X1_KOPIE_L)
	LDS XH,(adr_GRAFIC_X1_KOPIE_H)
	LDS YL,(adr_GRAFIC_Y1_KOPIE_L)
	LDS YH,(adr_GRAFIC_Y1_KOPIE_H)
	STS(adr_GRAFIC_X1_L),XL
	STS(adr_GRAFIC_X1_H),XH
	STS(adr_GRAFIC_Y1_L),YL
	STS(adr_GRAFIC_Y1_H),YH
	LDS XL,(adr_GRAFIC_X2_KOPIE_L)
	LDS XH,(adr_GRAFIC_X2_KOPIE_H)
	LDS YL,(adr_GRAFIC_Y2_KOPIE_L)
	LDS YH,(adr_GRAFIC_Y2_KOPIE_H)
	STS(adr_GRAFIC_X2_L),XL
	STS(adr_GRAFIC_X2_H),XH
	STS(adr_GRAFIC_Y2_L),YL
	STS(adr_GRAFIC_Y2_H),YH
ret
