; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;		(adr_GRAFIC_X1_L)														
;		(adr_GRAFIC_X1_H)														
;		(adr_GRAFIC_Y1_L)														
;		(adr_GRAFIC_Y1_H)														
;		(adr_GRAFIC_LAENGE_L)													
;		(adr_GRAFIC_LAENGE_H)													
;		(adr_GRAFIC_WINKEL_L)													
;		(adr_GRAFIC_WINKEL_H)													
;																				
; Zeichnet einen Zeiger vom Punkt X,Y im Winkel und Lnge						
;																				
GRAFIC_ZEIGER:
	; (X)SINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_SINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_SINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal LNGE						
	LDS temp3,(adr_GRAFIC_LAENGE_L)
	LDS temp4,(adr_GRAFIC_LAENGE_H)
 	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_X_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_X_DIV
GRAFIC_ZEIGER_X_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_X_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	

	LDS XL,(adr_GRAFIC_X1_L)
	LDS XH,(adr_GRAFIC_X1_H)
	add temp1,XL
	adc temp2,XH
	STS(adr_GRAFIC_X2_L),temp1
	STS(adr_GRAFIC_X2_H),temp2
	;---------------------------------------------------
	; (Y) COSINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_COSINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_COSINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal LNGE						
	LDS temp3,(adr_GRAFIC_LAENGE_L)
	LDS temp4,(adr_GRAFIC_LAENGE_H)
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_Y_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_Y_DIV
GRAFIC_ZEIGER_Y_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_Y_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	

	LDS YL,(adr_GRAFIC_Y1_L)
	LDS YH,(adr_GRAFIC_Y1_H)
	add temp1,YL
	adc temp2,YH
	STS(adr_GRAFIC_Y2_L),temp1
	STS(adr_GRAFIC_Y2_H),temp2
	rjmp GRAFIC_LINIE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Prameter:																		
;		(adr_GRAFIC_X1_L)														
;		(adr_GRAFIC_X1_H)														
;		(adr_GRAFIC_Y1_L)														
;		(adr_GRAFIC_Y1_H)														
;		(adr_GRAFIC_WINKEL_L)													
;		(adr_GRAFIC_WINKEL_H)													
;		(adr_GRAFIC_KREIS_RADIUS)												
;																				
; Zeichnet einen PUNKT vom Punkt X,Y im Winkel									
;																				
GRAFIC_ZEIGER_PUNKT:
	; (X)SINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_SINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_SINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal RADIUS						
	LDS temp3,(adr_GRAFIC_KREIS_RADIUS)
	clr temp4
 	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_PUNKT_X_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_PUNKT_X_DIV
GRAFIC_ZEIGER_PUNKT_X_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_PUNKT_X_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	
	LDS XL,(adr_GRAFIC_X1_L)
	LDS XH,(adr_GRAFIC_X1_H)
	add XL,temp1
	adc XH,temp2
	;---------------------------------------------------
	; (Y) COSINUSWERT aus WINKEL berechnen		
	ldi ZH, high(TABELLE_COSINUS*2)	; Z auf Tabelle				
	ldi ZL,  low(TABELLE_COSINUS*2)
	LDS temp8,(adr_GRAFIC_WINKEL_L)	; WINKEL
	LDS temp9,(adr_GRAFIC_WINKEL_H)
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	add ZL,temp8	; WINKEL addieren		
	adc ZH,temp9
	LPM temp1, Z+  	; aus Tabelle laden		
	LPM temp2, Z+  	; aus Tabelle laden		
	; WERT mal RADIUS						
	LDS temp3,(adr_GRAFIC_KREIS_RADIUS)
	clr temp4
	call FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT
	; RUNDEN (halben Divisor dazu addieren)		
	SBRC temp4,7	; Sprung bei positiv	
	rjmp GRAFIC_ZEIGER_PUNKT_Y_DIV_n
	subi temp1,BYTE1(-128)	; +128	
	sbci temp2,BYTE2(-128)
	sbci temp3,BYTE3(-128)
	sbci temp4,BYTE4(-128)
	rjmp GRAFIC_ZEIGER_PUNKT_Y_DIV
GRAFIC_ZEIGER_PUNKT_Y_DIV_n:
	subi temp1,BYTE1(128)	; -128	
	sbci temp2,BYTE2(128)
	sbci temp3,BYTE3(128)
	sbci temp4,BYTE4(128)
GRAFIC_ZEIGER_PUNKT_Y_DIV:
	; durch 256 (signiert)						
	mov temp1,temp2	
	mov temp2,temp3	
	LDS YL,(adr_GRAFIC_Y1_L)
	LDS YH,(adr_GRAFIC_Y1_H)
	add YL,temp1
	adc YH,temp2
	rjmp GRAFIC_PUNKT_X_Y
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1,R2 (werden nicht gesichert !	)								
; 					temp5+6+7+8															
FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	muls temp4, temp2		; (signed)ah * (signed)bh
	mov	temp7, r0
	mov	temp8, r1
	mul	temp3, temp1		; al * bl
	mov	temp5, r0
	mov	temp6, r1
	mulsu	temp4, temp1		; (signed)ah * bl
	sbc	temp8, r2
	add	temp6, r0
	adc	temp7, r1
	adc	temp8, r2
	mulsu	temp2, temp3		; (signed)bh * al
	sbc	temp8, r2
	add	temp6, r0
	adc	temp7, r1
	adc	temp8, r2

	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
