; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_INITIALISIERUNG:
	; auf EINGANG		
	cbi (TASTE_A_DDR) ,(TASTE_A_PIN_NR)
	cbi (TASTE_B_DDR) ,(TASTE_B_PIN_NR)
	cbi (TASTE_DG_DDR),(TASTE_DG_PIN_NR)
	; PULL-UP ein		
	sbi (TASTE_A_PORT) ,(TASTE_A_PIN_NR)
	sbi (TASTE_B_PORT) ,(TASTE_B_PIN_NR)
	sbi (TASTE_DG_PORT),(TASTE_DG_PIN_NR)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_ABFRAGE_TEMP:
	WDR
	LDS temp,(adr_TASTE)
	tst temp					; Taste ?		
	brne TASTEN_ABFRAGE_w1		; ja			
	ret
;-------------------------------------------------------------------------------
TASTEN_ABFRAGE_w1:
	BEEP_ON
	call GRAFIC_CLEAR
	STS(adr_DREHGEBER_WERT),NULL
	STS(adr_DREHGEBER_AKTIV),EINS
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	LED_GRUEN_BIG_OFF
	LED_GELB_BIG_OFF
	LED_ROT_BIG_OFF
	LDS temp,(adr_TASTE)
	STS(adr_TASTE),NULL
	BEEP_OFF
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; irgend eine Taste bettigt ?													
TASTE_CARRY:
	call TASTEN_ABFRAGE_TEMP
	tst temp
	brne TASTE_YES
	CLC 		; Clear Carry
	ret
;-------------------------------------------------------------------------------
TASTE_YES:
	SEC 		; Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Taste "A" bettigt ?															
TASTE_A_CARRY:
	call TASTEN_ABFRAGE_TEMP
	cpi temp,(TASTE_A)
	breq TASTE_A_YES
	CLC 		; Clear Carry
	ret
;-------------------------------------------------------------------------------
TASTE_A_YES:
	SEC 		; Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Taste "A" bettigt ?															
TASTE_B_CARRY:
	call TASTEN_ABFRAGE_TEMP
	cpi temp,(TASTE_B)
	breq TASTE_B_YES
	CLC 		; Clear Carry
	ret
;-------------------------------------------------------------------------------
TASTE_B_YES:
	SEC 		; Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Taste "DG" (Drehgeber) bettigt ?												
TASTE_DG_CARRY:
	call TASTEN_ABFRAGE_TEMP
	cpi temp,(TASTE_DG)
	breq TASTE_DG_YES
	CLC 		; Clear Carry
	ret
;-------------------------------------------------------------------------------
TASTE_DG_YES:
	SEC 		; Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

