; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "2"																		
ZAHL1_TEMP1:
	cpi temp1,9+1			; BERLAUF ?
	brlo ZAHL1_TEMP1_w
	ldi temp,(ERROR_ZAHL)	; ERROR		
	call ERROR_SAVE_TEMP
	jmp  ASCII_FRAGEZEICHEN
;-------------------------------------------------------------------------------
ZAHL1_TEMP1_w:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	jmp  ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "12"	no Space															
ZAHL2_TEMP1_FIX:
	cpi temp1,99+1	; BERLAUF ?		
	brlo ZAHL2_TEMP1_FIX_w
	ldi temp,(ERROR_ZAHL)	; ERROR		
	call ERROR_SAVE_TEMP
	call ASCII_FRAGEZEICHEN
	jmp  ASCII_FRAGEZEICHEN
;-------------------------------------------------------------------------------
ZAHL2_TEMP1_FIX_w:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	mov temp, temp2			; 2.ZEICHEN 
	call ASCII_TEMP	
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	jmp  ASCII_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "12"																		
ZAHL2_TEMP1:
	tst temp1
	brne ZAHL2_TEMP1_w
	call ASCII_MINUS2
	jmp  ASCII_SPACE
;-------------------------------------------------------------------------------
ZAHL2_TEMP1_w:
	cpi temp1,99+1	; BERLAUF ?		
	brlo ZAHL2_TEMP1_w2
	ldi temp,(ERROR_ZAHL)	; ERROR		
	call ERROR_SAVE_TEMP
	call ASCII_FRAGEZEICHEN
	call ASCII_FRAGEZEICHEN
	jmp ASCII_SPACE
;-------------------------------------------------------------------------------
ZAHL2_TEMP1_w2:

	clr temp2
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9 (temp)		
	jmp ANZEIGE_ZIFFERN2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "012"																	
ZAHL_TEMP1:
	tst temp1
	brne ZAHL_TEMP1_w
	call ASCII_MINUS3
	jmp ASCII_SPACE
;-------------------------------------------------------------------------------
ZAHL_TEMP1_w:
	clr temp2
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32	; INPUT: temp1...4 OUTPUT: Temp1...9+temp		
	jmp ANZEIGE_ZIFFERN3
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "999"																	
ZAHL3_TEMP1_2:
	tst temp1
	brne ZAHL3_TEMP1_2_w
	tst temp2
	brne ZAHL3_TEMP1_2_w
	call ASCII_MINUS3
	jmp ASCII_SPACE
;-------------------------------------------------------------------------------
ZAHL3_TEMP1_2_w:
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32
	jmp ANZEIGE_ZIFFERN3
; ##############################################################################
; ##############################################################################
; ##############################################################################
; z.B. "0012"																	
ZAHL4_TEMP1_2:
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32
	jmp ANZEIGE_ZIFFERN4
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1 + TEMP2															
ZAHL_TEMP1_2:
	clr temp3
	clr temp4
 	rcall FUNCTION_HEX_ASC_32
	mov temp6,temp5
	mov temp5,temp4
	ldi temp4,'.'

	cpi temp6,'0'
	brne ANZEIGE_5_STELLEN_RUN
	ldi temp6,' '

	cpi temp5,'0'
	brne ANZEIGE_5_STELLEN_RUN
	ldi temp5,' '
	ldi temp4,' '

	cpi temp3,'0'
	brne ANZEIGE_5_STELLEN_RUN
	ldi temp3,' '

	cpi temp2,'0'
	brne ANZEIGE_5_STELLEN_RUN
	ldi temp2,' '

ANZEIGE_5_STELLEN_RUN:
	jmp ANZEIGE_ZIFFERN6
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1															  		
; z.B. +32767																	
; z.B. -32768																	
ZAHL_SIGNIERT_TEMP1_2:
	tst temp2
	brmi ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2_n
	call ASCII_PLUS	; VORZEICHEN	
	rjmp ZAHL_TEMP1_2
ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2_n:
	call ASCII_MINUS	; VORZEICHEN	
	COM temp1			; BETRAG bilden	
	COM temp2
	add temp1,EINS
	adc temp2,NULL
	jmp ZAHL_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; (0...16.777.215)																
ZAHL_TEMP1_2_3:
	clr temp4
 	call FUNCTION_HEX_ASC_32
	jmp ANZEIGE_ZIFFERN8
; ##############################################################################
; ##############################################################################
; ##############################################################################
;(0...4.294.967.295)															
ZAHL_TEMP1_2_3_4:
 	call FUNCTION_HEX_ASC_32
	cpi temp,'0'
	brne ZAHL32_10
	cpi temp9,'0'
	brne ZAHL32_9
	cpi temp8,'0'
	brne ZAHL32_8
	cpi temp7,'0'
	brne ZAHL32_7
	cpi temp6,'0'
	brne ZAHL32_6
	cpi temp5,'0'
	brne ZAHL32_5
	cpi temp4,'0'
	brne ZAHL32_4
	cpi temp3,'0'
	brne ZAHL32_3
	cpi temp2,'0'
	brne ZAHL32_2
	rjmp ZAHL32_1
;---------------------------------------------------------------------------
ZAHL32_10:
	call ASCII_TEMP	; temp!  10.ZEICHEN 	
	call ASCII_PUNKT		; .			
ZAHL32_9:
	mov temp, temp9			; 9.ZEICHEN 
	call ASCII_TEMP	
ZAHL32_8:
	mov temp, temp8			; 8.ZEICHEN 
	call ASCII_TEMP
ZAHL32_7:
	mov temp, temp7			; 7.ZEICHEN 
	call ASCII_TEMP	
	call ASCII_PUNKT		; .			
ZAHL32_6:
	mov temp, temp6			; 6.ZEICHEN 
	call ASCII_TEMP
ZAHL32_5:
	mov temp, temp5			; 5.ZEICHEN 
	call ASCII_TEMP
ZAHL32_4:
	mov temp, temp4			; 4.ZEICHEN 
	call ASCII_TEMP
	call ASCII_PUNKT		; .			
ZAHL32_3:
	mov temp, temp3			; 3.ZEICHEN 
	call ASCII_TEMP	
ZAHL32_2:
	mov temp, temp2			; 2.ZEICHEN 
	call ASCII_TEMP	
ZAHL32_1:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	call ASCII_TEMP
	jmp ASCII_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
;(0...4.294.967.295)															
ZAHL_FIX_TEMP1_2_3_4:
 	call FUNCTION_HEX_ASC_32
	cpi temp,'0'
	brne ZAHL32_10

call ASCII_SPACE2		; 
	cpi temp9,'0'
	brne ZAHL32_9
	call ASCII_SPACE

	cpi temp8,'0'
	brne ZAHL32_8
	call ASCII_SPACE

	cpi temp7,'0'
	brne ZAHL32_7
	call ASCII_SPACE2		; 
	cpi temp6,'0'
	brne ZAHL32_6
	call ASCII_SPACE

	cpi temp5,'0'
	brne ZAHL32_5
	call ASCII_SPACE

	cpi temp4,'0'
	brne ZAHL32_4
	call ASCII_SPACE2		; 

	cpi temp3,'0'
	brne ZAHL32_3
	call ASCII_SPACE

	cpi temp2,'0'
	brne ZAHL32_2
	call ASCII_SPACE

	rjmp ZAHL32_1
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1...TEMP9 (temp)													
ANZEIGE_ZIFFERN10:
	call ASCII_TEMP	; temp!  10.ZEICHEN 	
ANZEIGE_ZIFFERN9:
	mov temp, temp9			; 9.ZEICHEN 
	call ASCII_TEMP	
ANZEIGE_ZIFFERN8:
	mov temp, temp8			; 8.ZEICHEN 
	call ASCII_TEMP
ANZEIGE_ZIFFERN7:
	mov temp, temp7			; 7.ZEICHEN 
	call ASCII_TEMP	
ANZEIGE_ZIFFERN6:
	mov temp, temp6			; 6.ZEICHEN 
	call ASCII_TEMP
ANZEIGE_ZIFFERN5:
	mov temp, temp5			; 5.ZEICHEN 
	call ASCII_TEMP
ANZEIGE_ZIFFERN4:
	mov temp, temp4			; 4.ZEICHEN 
	call ASCII_TEMP
ANZEIGE_ZIFFERN3:
	mov temp, temp3			; 3.ZEICHEN 
	call ASCII_TEMP	
ANZEIGE_ZIFFERN2:
	mov temp, temp2			; 2.ZEICHEN 
	call ASCII_TEMP	
ANZEIGE_ZIFFERN1:
	mov temp, temp1			; 1.ZEICHEN (1-er Stelle)	
	call ASCII_TEMP
	jmp ASCII_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 11/2014															
;																			
;	Value: 0...	4.294.967.295 (0xFFFFFFFF)									
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			temp	(1.000.000.000-er Stelle)								
; 																			
FUNCTION_HEX_ASC_32:
;---------------------------------------------------------------------------
	clr temp			
FUNCTION_HEX_ASC_10:	; 1.000.000.000er Stelle
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNCTION_HEX_ASC_10
	subi temp, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNCTION_HEX_ASC_9:	; 100.000.000er Stelle
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNCTION_HEX_ASC_9
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNCTION_HEX_ASC_8:	; 10.000.000er Stelle
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNCTION_HEX_ASC_8
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNCTION_HEX_ASC_7:	; 1.000.000er Stelle
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNCTION_HEX_ASC_7
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_6:	; 100.000er Stelle
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_6
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------	clr temp
	clr temp5
FUNCTION_HEX_ASC_5:	; 10.000er Stelle
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNCTION_HEX_ASC_5
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNCTION_HEX_ASC_4:	; 1.000er Stelle
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNCTION_HEX_ASC_4
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNCTION_HEX_ASC_3:	; 100er Stelle
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNCTION_HEX_ASC_3
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNCTION_HEX_ASC_2:	; 10er Stelle
	inc temp2
	subi temp1, low  (10)
	brcc FUNCTION_HEX_ASC_2
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNCTION_HEX_ASC_1:	; 1er Stelle
	subi temp1, -48		; HEX->ASC	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
ZAHL_HEX_NONULL_TEMP1x:
	tst temp1
	brne ZAHL_HEX_TEMP1
	push temp1
	call ASCII_MINUS2
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
ZAHL_HEX_TEMP1:
	tst temp1
	brne ZAHL_HEX_RUN
	jmp ASCII_MINUS2
;-------------------------------------------------------------------------------
ZAHL_HEX_RUN:
	push temp1	; SICHERUNGSKOPIE						
	; oberes NIBBLE bearbeiten				
	mov temp,temp1	
	swap temp					; NIBBLES tausch	
	call ZAHL_HEX_UMWANDLUNG	; INP/OUT: temp		
	call ASCII_TEMP
	; unteres NIBBLE bearbeiten				
	mov temp,temp1	
	call ZAHL_HEX_UMWANDLUNG	; INP/OUT: temp		
	call ASCII_TEMP
	pop temp1	; SICHERUNGSKOPIE wieder herstellen		
	ret
;-------------------------------------------------------------------------------
ZAHL_HEX_UMWANDLUNG:
	; BITMUSTER	
	andi temp,0b00001111
	; vergleich	
	cpi temp,10
	brsh ZAHL_HEX_UMWANDLUNG_A_F
ZAHL_HEX_UMWANDLUNG_0_9:
	subi temp,-48
	ret
ZAHL_HEX_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																	
; OUT: (z.B."00000001")															
;																				
ZAHL_BIN_TEMP1:
	push temp1
	andi temp1,0b10000000
	call ZAHL_BIN_VIEW
	pop temp1

	push temp1
	andi temp1,0b01000000
	call ZAHL_BIN_VIEW
	pop temp1

	push temp1
	andi temp1,0b00100000
	call ZAHL_BIN_VIEW
	pop temp1

	push temp1
	andi temp1,0b00010000
	call ZAHL_BIN_VIEW
	pop temp1

	push temp1
	andi temp1,0b00001000
	call ZAHL_BIN_VIEW
	pop temp1

	push temp1
	andi temp1,0b00000100
	call ZAHL_BIN_VIEW
	pop temp1

	push temp1
	andi temp1,0b00000010
	call ZAHL_BIN_VIEW
	pop temp1

	push temp1
	andi temp1,0b00000001
	call ZAHL_BIN_VIEW
	pop temp1
	ret
;-------------------------------------------------------------------------------
ZAHL_BIN_VIEW:
	tst temp1
	breq ZAHL_BIN_VIEW_w
	jmp ASCII_1
ZAHL_BIN_VIEW_w:
	jmp ASCII_0
; ##############################################################################
; ##############################################################################
; ##############################################################################
