; ##############################################################################
; ##############################################################################
; ##############################################################################
DREHGEBER_INITIALISIEREN:
	; auf EINGANG		
	cbi (DREH_A_DDR),(DREH_A_PIN_NR)
	cbi (DREH_B_DDR),(DREH_B_PIN_NR)
	; PULL-UP ein		
	sbi (DREH_A_PORT),(DREH_A_PIN_NR)
	sbi (DREH_B_PORT),(DREH_B_PIN_NR)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DREH_ABFRAGEi:
	LDS temp,(adr_DREHGEBER_WERT)
	tst temp
	breq DREH_RUNi 
	ret
;-------------------------------------------------------------------------------
DREH_RUNi:
	LDS temp,(adr_DREHGEBER_ROHBITS)
	LSL temp							; 1xlinks			
	LSL temp							; 1xlinks			
	sbis (DREH_A_PIN),(DREH_A_PIN_NR)	; Kanal-A abfragen	
	SBR temp,(1)
	sbis (DREH_B_PIN),(DREH_B_PIN_NR)	; Kanal-B abfragen	
	SBR temp,(2)
	STS(adr_DREHGEBER_ROHBITS),temp
	andi temp,0b00000011
	LDS temp1,(adr_DREHGEBER_OLD)
	cp temp,temp1
	brne DREH_wi
	ret
;-------------------------------------------------------------------------------
; (00) 01 (11) 10 (00)															
;   <-------------->															
DREH_wi:
	STS(adr_DREHGEBER_OLD),temp
	LDS temp1,(adr_DREHGEBER_BITMUSTER)
	LSR temp	; C kullert raus	
	ROL temp1 	; C reinscheiben	
	LSR temp	; C kullert raus	
	ROL temp1 	; C reinscheiben	
	STS(adr_DREHGEBER_BITMUSTER),temp1
	andi temp1,0b00111111	; begrenzen			
	cpi temp1,0x0B
	breq DREH_RICHTUNG_1i
	cpi temp1,0x34
	breq DREH_RICHTUNG_1i
	cpi  temp1,0x07
	breq DREH_RICHTUNG_2i
	cpi  temp1,0x38
	breq DREH_RICHTUNG_2i
	ret
; ------------------------------------------------------------------------------
DREH_RICHTUNG_1i:
	STS(adr_DREHGEBER_AKTIV),EINS
	STS(adr_DREHGEBER_WERT),EINS
	ret
; ------------------------------------------------------------------------------
DREH_RICHTUNG_2i:
	STS(adr_DREHGEBER_AKTIV),EINS
	ldi temp,(-1)
	STS(adr_DREHGEBER_WERT),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DREHGEBER_TEMP1_4:
	LDS temp,(adr_DREHGEBER_WERT)
	STS(adr_DREHGEBER_WERT),NULL
	cpi temp, (1)
	breq DREHGEBER_PLUS
	cpi temp,(-1)
	breq DREHGEBER_MINUS
	ret
;-------------------------------------------------------------------------------
DREHGEBER_MINUS:
	call BEEP_KURZ
	sub temp1,EINS
	sbc temp2,NULL
	sbc temp3,NULL
	sbc temp4,NULL
	ret
;-------------------------------------------------------------------------------
DREHGEBER_PLUS:
	call BEEP_KURZ
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DREHGEBER_C:
	LDS temp,(adr_DREHGEBER_WERT)
	tst temp
	brne DREHGEBER_YES
	CLC 		; Clear Carry
	ret
;-------------------------------------------------------------------------------
DREHGEBER_YES:
	SEC 		; Set Carry
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
