; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_INITIALISIEREN:
	STS(adr_GRAFIC_PUNKT_GROESSE),NULL

	ldi XL,LOW (XSITZE/2+30)			; X								
	ldi XH,HIGH(XSITZE/2+30)
	ldi YL,LOW (YSITZE/2)			; Y								
	ldi YH,HIGH(YSITZE/2)	
	STS(adr_GRAFIC_X1_L),XL		
	STS(adr_GRAFIC_X1_H),XH
	STS(adr_GRAFIC_Y1_L),YL		
	STS(adr_GRAFIC_Y1_H),YH	
	call GRAFIC_PUNKT_X_Y			; Mittelpunkt	
;-------------------------------------------------------------------------------
	call GPS_CLEAR
	call GPS_GSV_DATA_CLEAR
;-------------------------------------------------------------------------------
; Kreis zeichnen																
	ldi temp1,90
	rcall SAT_CALC_TEMP1
	STS(adr_GRAFIC_KREIS_RADIUS),temp1	; RADIUS		
	clr ZL
	clr ZH
SAT_INI_s:
	STS(adr_GRAFIC_WINKEL_L),ZL;Azimuth(000-359)
	STS(adr_GRAFIC_WINKEL_H),ZH
	push ZL
	push ZH	
	call GRAFIC_ZEIGER_PUNKT
	pop ZH
	pop ZL
	adiw ZL,1
	cpi ZL,low (3600)
	brne SAT_INI_s
	cpi ZH,high(3600)
	brne SAT_INI_s
;-------------------------------------------------------------------------------
; Kreis zeichnen																
	ldi temp1,45
	rcall SAT_CALC_TEMP1
	STS(adr_GRAFIC_KREIS_RADIUS),temp1	; RADIUS		
	clr ZL
	clr ZH
SAT_INI_s2:
	STS(adr_GRAFIC_WINKEL_L),ZL;Azimuth(000-359)
	STS(adr_GRAFIC_WINKEL_H),ZH
	push ZL
	push ZH	
	call GRAFIC_ZEIGER_PUNKT
	pop ZH
	pop ZL
	adiw ZL,1
	cpi ZL,low (3600)
	brne SAT_INI_s2
	cpi ZH,high(3600)
	brne SAT_INI_s2
;-------------------------------------------------------------------------------
	ldi temp,1
	STS(adr_GRAFIC_PUNKT_GROESSE),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_CALC_TEMP1:
	ldi temp,11
	MUL temp1,temp	; mal 11, dann durch 8
	LSR R1	; :2
	ROR R0
	LSR R1	; :2
	ROR R0
	LSR R1	; :2
	ROR R0
	mov temp1,R0
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_10_TEMP1_2:
	mov R0,temp1	; Kopie	
	mov R1,temp2

	LSL temp1		; x2	
	ROL temp2
	LSL temp1		; x2	
	ROL temp2
	LSL temp1		; x2	
	ROL temp2

	add temp1,R0	; Kopie addieren		
	adc temp2,R1
	add temp1,R0	; Kopie addieren		
	adc temp2,R1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_VIEW:
	rcall SAT_VIEW_BAHNDATEN

	ldi ZL,low (adr_GPS_GSV_DATA)
	ldi ZH,high(adr_GPS_GSV_DATA)
;-------------------------------------------------------------------------------
SAT_VIEW_s:
	LD temp1,Z+; PRN number(00-99)
	tst temp1
	brne SAT_VIEW_w
	ret
;-------------------------------------------------------------------------------
SAT_VIEW_w:
	ldi temp1,90
	LD temp,Z+							; Elevation(00-90)	
	sub temp1,temp						; Umrechnen			
	call SAT_CALC_TEMP1					; Umrechnen			
	STS(adr_GRAFIC_KREIS_RADIUS),temp1	; Elevation(00-90)	
	LD temp1,Z+							; Azimuth(000-359)	
	LD temp2,Z+							; Azimuth(000-359)	
	call SAT_10_TEMP1_2					; x10				
	STS(adr_GRAFIC_WINKEL_L),temp1		; Azimuth(000-359)	
	STS(adr_GRAFIC_WINKEL_H),temp2
	LD temp,Z+							; SNR db(00-99)		
	push ZL
	push ZH
	call GRAFIC_ZEIGER_PUNKT
	pop ZH
	pop ZL
	rjmp SAT_VIEW_s

; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_VIEW_BAHNDATEN:
	ldi ZL,low (adr_GPS_GSV_DATA)
	ldi ZH,high(adr_GPS_GSV_DATA)
	call ZEILE_2
	call SAT_VIEW_ZEILE
	call ZEILE_3
	call SAT_VIEW_ZEILE
	call ZEILE_4
	call SAT_VIEW_ZEILE
	call ZEILE_5
	call SAT_VIEW_ZEILE
	call ZEILE_6
	call SAT_VIEW_ZEILE
	call ZEILE_7
	call SAT_VIEW_ZEILE
	call ZEILE_8
	call SAT_VIEW_ZEILE
	call ZEILE_9
	call SAT_VIEW_ZEILE
	call ZEILE_10
	call SAT_VIEW_ZEILE
	call ZEILE_11
	call SAT_VIEW_ZEILE
	call ZEILE_12
	call SAT_VIEW_ZEILE
	call ZEILE_13
	call SAT_VIEW_ZEILE
	call ZEILE_14
	call SAT_VIEW_ZEILE
	call ZEILE_15
	call SAT_VIEW_ZEILE
	call ZEILE_16
	call SAT_VIEW_ZEILE
	call ZEILE_17
	call SAT_VIEW_ZEILE
ret
;-------------------------------------------------------------------------------
SAT_VIEW_ZEILE:
	LD temp1,Z+
	call ZAHL2_temp1

	LD temp1,Z+
	call ZAHL2_temp1

	LD temp1,Z+
	LD temp2,Z+
	call ZAHL3_temp1_2

	LD temp1,Z+
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_SEKTOR_READ:
	LDS SEKTOR0,(adr_SEKTOR0)
	LDS SEKTOR1,(adr_SEKTOR1)
	LDS SEKTOR2,(adr_SEKTOR2)
	LDS SEKTOR3,(adr_SEKTOR3)

	call GPS_CLEAR
	call GPS_GSV_DATA_CLEAR
	call SD_SEKTOR_READ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_CALC_SD_STARTSEKTOR:
	call GPS_CALC_SD_SEKTOR_C
	brcs SAT_CALC_SD_RUN
	STS(adr_SEKTOR0),NULL
	STS(adr_SEKTOR1),NULL
	STS(adr_SEKTOR2),NULL
	STS(adr_SEKTOR3),NULL
	ret
;-------------------------------------------------------------------------------
SAT_CALC_SD_RUN:
	mov temp1,SEKTOR0
	mov temp2,SEKTOR1
	mov temp3,SEKTOR2
	mov temp4,SEKTOR3
.equ GPS=60*24*4
	ldi temp5,BYTE1(GPS)	
	ldi temp6,BYTE2(GPS)	
	ldi temp7,BYTE3(GPS)	
	ldi temp8,BYTE4(GPS)	

	sub temp1,temp5
	sbc temp2,temp6
	sbc temp3,temp7
	sbc temp4,temp8
	tst temp4
	brpl SAT_CALC_SD_EXIT
	clr temp1
	clr temp2
	clr temp3
	clr temp4
;-------------------------------------------------------------------------------
SAT_CALC_SD_EXIT:
	STS(adr_SEKTOR0),temp1
	STS(adr_SEKTOR1),temp2
	STS(adr_SEKTOR2),temp3
	STS(adr_SEKTOR3),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_CALC_SEKTOR_NEXT:
	call GPS_CALC_SD_SEKTOR_C
	brcc SAT_SEKTOR_NEXT_EXIT
;-------------------------------------------------------------------------------
	LDS temp1,(adr_SEKTOR0)
	LDS temp2,(adr_SEKTOR1)
	LDS temp3,(adr_SEKTOR2)
	LDS temp4,(adr_SEKTOR3)
	cp SEKTOR3,temp4
	brne SAT_SEKTOR_NEXT_EXIT
	cp SEKTOR2,temp3
	brne SAT_SEKTOR_NEXT_EXIT
	cp SEKTOR1,temp2
	brne SAT_SEKTOR_NEXT_EXIT
	cp SEKTOR0,temp1
	brne SAT_SEKTOR_NEXT_EXIT
	ret
;-------------------------------------------------------------------------------
SAT_SEKTOR_NEXT_EXIT:
	LDS temp1,(adr_SEKTOR0)
	LDS temp2,(adr_SEKTOR1)
	LDS temp3,(adr_SEKTOR2)
	LDS temp4,(adr_SEKTOR3)
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	STS(adr_SEKTOR0),temp1
	STS(adr_SEKTOR1),temp2
	STS(adr_SEKTOR2),temp3
	STS(adr_SEKTOR3),temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SAT_STATISTIK_PRN:
	ldi ZL,low (adr_GPS_STATISTIK)
	ldi ZH,high(adr_GPS_STATISTIK)
	call ZEILE_2
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_3
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_4
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_5
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_6
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_7
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_8
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_9
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_10
	call MENUE_SAT_STATISTIK_ZEILE
	call ZEILE_11
	call MENUE_SAT_STATISTIK_ZEILE
	ret
;-------------------------------------------------------------------------------
MENUE_SAT_STATISTIK_ZEILE:
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
	LD temp1,Z+
	call ZAHL2_temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
