; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	STS(adr_GRAFIC_FONT),NULL
	call ZEILE_0
	call TASTEN_ABFRAGE_TEMP	; TASTEN	
	LDS temp1,(adr_MENUE)
	mov temp2,temp1
	call DREHGEBER_TEMP1_4		; DREHGEBER	
	tst temp1
	brpl MENUE_w
	clr temp1
;-------------------------------------------------------------------------------
MENUE_w:
	STS(adr_MENUE),temp1
	cp temp1,temp2				; Drehbewegung	
	breq MENUE_RUN
	call GRAFIC_CLEAR
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL, LOW(MENUE_SPRUNGMARKE)	; Z		
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	LSL temp			; x2, wegen "jmp (2 Words)"	
	add ZL,temp
	adc ZH,NULL
	IJMP				; SPRUNG nach Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SPRUNGMARKE:
	jmp ANALOGUHR
	jmp ANZEIGE_ZEIT_DATUM
	jmp MENUE_HILFE
	jmp MENUE_GPS_STATUS
	jmp MENUE_SAT_VIEW
	jmp MENUE_SAT_AKTUELL
	jmp MENUE_SAT_PLAY	
	jmp MENUE_SAT_STATISTIK
	jmp MENUE_GSV
	jmp MENUE_VIEW_GPS_DATA
	jmp MENUE_VIEW_SD_DATA
	jmp MENUE_SEKTOR_VIEW_ASCII
	jmp MENUE_SD_PLAY
	jmp ANZEIGE_SD_INFO
	jmp MENUE_SD_LL_FORMATIERUNG
	jmp MENUE_SD_READ_TEST
	jmp MENUE_EDIT_TV_KORREKTUR
	jmp MENUE_EDIT_UTC_KORREKTUR
	jmp ANZEIGE_SYSTEM
	jmp MENUE_WERKSEINSTELLUNG
	jmp ANZEIGE_BEGRUESSUNG
	jmp MENUE_ASCII_TEST0
	jmp MENUE_ASCII_TEST1
	jmp GRAFIC_TEST_A
	jmp GRAFIC_TEST_PUNKT
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	jmp MENUE_BAUSTELLE
	STS(adr_MENUE),NULL
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_BAUSTELLE:
	call ZEILE_2
	STS(adr_ASCII_INVERS),EINS
	call TEXT_BAUSTELLE
	STS(adr_ASCII_INVERS),NULL
	call ASCII_SPACE
	LDS temp1,(adr_MENUE)
	call ZAHL_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_HILFE:
	call ZEILE_3
	call TEXT_LED
	call ASCII_n_
	call ASCII_o_

	call ZEILE_6
	call TEXT_LED
	call ASCII_2
	call ASCII_D


	call ZEILE_9
	call TEXT_LED
	call ASCII_3
	call ASCII_D

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_VIEW_GPS_DATA:
	LDS temp,(adr_USART_TIMER)
	tst temp
	breq MENUE_VIEW_GPS_DATA_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_VIEW_GPS_DATA_RUN:
	ldi ZL,low (adr_GPS_BUFFER)
	ldi ZH,high(adr_GPS_BUFFER)
	call ANZEIGE_ASCII_ZEILE_Z	; 0
	call ANZEIGE_ASCII_ZEILE_Z	; 1
	call ANZEIGE_ASCII_ZEILE_Z	; 2
	call ANZEIGE_ASCII_ZEILE_Z	; 3
	call ANZEIGE_ASCII_ZEILE_Z	; 4
	call ANZEIGE_ASCII_ZEILE_Z	; 5
	call ANZEIGE_ASCII_ZEILE_Z	; 6
	call ANZEIGE_ASCII_ZEILE_Z	; 7
	call ANZEIGE_ASCII_ZEILE_Z	; 8
	call ANZEIGE_ASCII_ZEILE_Z	; 9
	call ANZEIGE_ASCII_ZEILE_Z	;10
	call ANZEIGE_ASCII_ZEILE_Z	;11
	call ANZEIGE_ASCII_ZEILE_Z	;12
	call ANZEIGE_ASCII_ZEILE_Z	;13
	call ANZEIGE_ASCII_ZEILE_Z	;14
	call ANZEIGE_ASCII_ZEILE_Z	;15
	call ANZEIGE_ASCII_ZEILE_Z	;16
	call ANZEIGE_ASCII_ZEILE_Z	;17
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_VIEW_SD_DATA:
	LDS temp,(adr_USART_TIMER)
	tst temp
	breq MENUE_VIEW_SD_DATA_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_VIEW_SD_DATA_RUN:
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	call ANZEIGE_ASCII_ZEILE_Z	; 0
	call ANZEIGE_ASCII_ZEILE_Z	; 1
	call ANZEIGE_ASCII_ZEILE_Z	; 2
	call ANZEIGE_ASCII_ZEILE_Z	; 3
	call ANZEIGE_ASCII_ZEILE_Z	; 4
	call ANZEIGE_ASCII_ZEILE_Z	; 5
	call ANZEIGE_ASCII_ZEILE_Z	; 6
	call ANZEIGE_ASCII_ZEILE_Z	; 7
	call ANZEIGE_ASCII_ZEILE_Z	; 8
	call ANZEIGE_ASCII_ZEILE_Z	; 9
	call ANZEIGE_ASCII_ZEILE_Z	;10
	call ANZEIGE_ASCII_ZEILE_Z	;11
	call ANZEIGE_ASCII_ZEILE_Z	;12
	call ANZEIGE_ASCII_ZEILE_Z	;13
	call ANZEIGE_ASCII_ZEILE_Z	;14
	call ANZEIGE_ASCII_ZEILE_Z	;15
	call ANZEIGE_ASCII_ZEILE_Z	;16
	call ANZEIGE_ASCII_ZEILE_Z	;17
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; aktuelle Stattelitenposition graphisch anzeigen								
MENUE_SAT_AKTUELL:
	LDS temp,(adr_USART_TIMER)
	tst temp
	breq MENUE_SAT_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SAT_RUN:
	LDS temp,(adr_DREHGEBER_AKTIV)
	STS(adr_DREHGEBER_AKTIV),NULL
	tst temp
	breq MENUE_SAT_START
;-------------------------------------------------------------------------------
	call TEXT_SAT
	call TEXT_AKTUELL
	call SAT_INITIALISIEREN
	ret
;-------------------------------------------------------------------------------
MENUE_SAT_START:
	call ZEILE_1
	call TEXT_GPS
	call ANZEIGE_GPS_ZEIT_KURZ
	call SAT_VIEW
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; gespeicherte Stattelitenposition graphisch anzeigen							
MENUE_SAT_PLAY:
	LDS temp,(adr_DREHGEBER_AKTIV)
	STS(adr_DREHGEBER_AKTIV),NULL
	tst temp
	breq MENUE_SAT_PLAY_START
;-------------------------------------------------------------------------------
	call TEXT_SAT
	call TEXT_PLAY
	call SAT_INITIALISIEREN
	call SAT_CALC_SD_STARTSEKTOR
	ret
;-------------------------------------------------------------------------------
MENUE_SAT_PLAY_START:
	call SAT_SEKTOR_READ
	call ZEILE_1
	call TEXT_SD
	call TEXT_SEKTOR
	call ANZEIGE_SEKTOR_DEZ_KURZ
;-------------------------------------------------------------------------------
	call GPS_GSV_C			; GPS_GSV	
	brcc MENUE_SAT_PLAY_NEXT
	call SAT_VIEW			; VIEW		
;-------------------------------------------------------------------------------
MENUE_SAT_PLAY_NEXT:
	call SAT_CALC_SEKTOR_NEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SAT_VIEW:
	call SAT_STATISTIK_PRN
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SAT_STATISTIK:
	LDS temp,(adr_DREHGEBER_AKTIV)
	STS(adr_DREHGEBER_AKTIV),NULL
	tst temp
	breq MENUE_SAT_STATISTIK_START
;-------------------------------------------------------------------------------
	call TEXT_SAT
	call SAT_CALC_SD_STARTSEKTOR
	ret
;-------------------------------------------------------------------------------
MENUE_SAT_STATISTIK_START:
	call SAT_SEKTOR_READ
;-------------------------------------------------------------------------------
	call ZEILE_1
	call TEXT_SD
	call TEXT_SEKTOR
	call ANZEIGE_SEKTOR_DEZ_KURZ
;-------------------------------------------------------------------------------
	call GPS_GSV_C			; GPS_GSV	
	brcc MENUE_SAT_STATISTIK_NEXT
;-------------------------------------------------------------------------------
	call SAT_STATISTIK_PRN
;-------------------------------------------------------------------------------
MENUE_SAT_STATISTIK_NEXT:
	call SAT_CALC_SEKTOR_NEXT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_GPS_STATUS:
	call TEXT_GPS
	call TEXT_STATUS
	call ZEILE_1
;-------------------------------------------------------------------------------
	call ZEILE_2
	call TEXT_UTC
	call ASCII_SPACE2
	call ANZEIGE_GPS_ZEIT_KURZ
	call ANZEIGE_GPS_DATUM_KURZ
;-------------------------------------------------------------------------------
	call ZEILE_3
	call TEXT_QUARZ
	call ANZEIGE_ZEIT_KURZ
	call ASCII_SPACE
	call TEXT_UTC
	LDS temp1,(adr_UTC)
	call ZAHL_TEMP1
;-------------------------------------------------------------------------------
	call ZEILE_5
	call TEXT_STATUS
	LDS temp,(adr_GPS_RMC_WARNUNG)
	call ASCII_TEMP						; A/W		
	call ASCII_SPACE
	LDS temp1,(adr_GPS_GSA_FIX_MODUS)	;1D/2D/3D	
	call ZAHL1_TEMP1
	call ASCII_D
	call ASCII_SPACE
;-------------------------------------------------------------------------------
	call ZEILE_7
	call TEXT_SAT
	LDS temp1,(adr_GPS_GGA_SAT_USE)		; Sat		
	call ZAHL2_TEMP1
	call ASCII_SCHRAEGSTRICH
	call ASCII_SPACE
	LDS temp1,(adr_GPS_GSV_SAT_VIEW)	; Sat		
	call ZAHL2_TEMP1

	call TEXT_MAX
	LDS temp1,(adr_GPS_GSV_SAT_VIEW_MAX); Sat		
	call ZAHL2_TEMP1
;-------------------------------------------------------------------------------
	call ZEILE_9
	call TEXT_GSA
	LDS temp1,(adr_GPS_GSA_ID0)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID1)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID2)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID3)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID4)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID5)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID6)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID7)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID8)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID9)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID10)
	call ZAHL2_TEMP1
	LDS temp1,(adr_GPS_GSA_ID11)
	call ZAHL2_TEMP1
;-------------------------------------------------------------------------------
	call ZEILE_11
	call TEXT_SD
	call TEXT_SEKTOR
	call GPS_CALC_SD_SEKTOR_C			; SEKTOR	
	call ANZEIGE_SEKTOR_DEZ_KURZ
;-------------------------------------------------------------------------------
	call ZEILE_13
	call TEXT_USART
	call TEXT_RS232
	LDS temp1,(adr_USART_BYTES_L)
	LDS temp2,(adr_USART_BYTES_H)
	call ZAHL3_TEMP1_2
	call TEXT_MAX
	LDS temp1,(adr_USART_BYTES_MAX_L)
	LDS temp2,(adr_USART_BYTES_MAX_H)
	call ZAHL3_TEMP1_2
	call TEXT_BUFFER
	ldi temp1,low (GPS_BUFFER_LEN)
	ldi temp2,high(GPS_BUFFER_LEN)
	call ZAHL3_TEMP1_2
;-------------------------------------------------------------------------------
	call ZEILE_16
	call TEXT_WARNUNG
	LDS temp1,(adr_WARNUNG)
	call ZAHL_HEX_TEMP1
	LDS temp1,(adr_WARNUNG_ANZAHL_L)
	LDS temp2,(adr_WARNUNG_ANZAHL_H)
	call ZAHL_TEMP1_2
;-------------------------------------------------------------------------------
	call ZEILE_17
	call TEXT_ERROR
	call ASCII_SPACE2
	LDS temp1,(adr_ERROR)
	call ZAHL_HEX_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_GSV:
	call TEXT_GPS
	call TEXT_GSV
	LDS temp,(adr_USART_TIMER)
	tst temp
	breq MENUE_GSV_w
	ret
;-------------------------------------------------------------------------------
MENUE_GSV_w:
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	rcall MENUE_GSV_SEARCH_Z_C
	brcs MENUE_GSV_START
	ret
;-------------------------------------------------------------------------------
MENUE_GSV_START:
	call ZEILE_0
;	call GRAFIC_CLEAR
	call TEXT_GPS
	call TEXT_GSV
	call ANZEIGE_GPS_ZEIT_KURZ
	call ANZEIGE_GPS_DATUM_KURZ
	call ANZEIGE_SEKTOR_DEZ_KURZ
;-------------------------------------------------------------------------------
 	ldi ZL,low (adr_GPS_GSV_DATA)
	ldi ZH,high(adr_GPS_GSV_DATA)
	call ZEILE_1	;
	call ASCII_1
	call ASCII_DOPPELPUNKT
	call ASCII_SPACE
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
	call ZEILE_2
	call ASCII_SPACE3
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
	call ZEILE_3	;
	call ASCII_2
	call ASCII_DOPPELPUNKT
	call ASCII_SPACE
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
	call ZEILE_4
	call ASCII_SPACE3
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
	call ZEILE_5	;
	call ASCII_3
	call ASCII_DOPPELPUNKT
	call ASCII_SPACE
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
	call ZEILE_6
	call ASCII_SPACE3
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
	call ZEILE_7	;
	call ASCII_4
	call ASCII_DOPPELPUNKT
	call ASCII_SPACE
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
	call ZEILE_8
	call ASCII_SPACE3
	rcall MENUE_GSV_Z
;-------------------------------------------------------------------------------
; GPGSV,,1...																	
MENUE_GSV_1x:
	call ZEILE_10
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	rcall MENUE_GSV_SEARCH_Z_C
	call MENUE_GSV_ANZEIGE
	rcall MENUE_GSV_SEARCH_Z_C
	brcs MENUE_GSV_2
	ret
;-------------------------------------------------------------------------------
; GPGSV,,2...																	
MENUE_GSV_2:
	call ZEILE_12
	call MENUE_GSV_ANZEIGE
	rcall MENUE_GSV_SEARCH_Z_C
	brcs MENUE_GSV_3
	ret
;-------------------------------------------------------------------------------
; GPGSV,,3...																	
MENUE_GSV_3:
	call ZEILE_14
	call MENUE_GSV_ANZEIGE
	rcall MENUE_GSV_SEARCH_Z_C
	brcs MENUE_GSV_4
	ret
;-------------------------------------------------------------------------------
; GPGSV,,1...																	
MENUE_GSV_4:
	call ZEILE_16
	call MENUE_GSV_ANZEIGE
	ret
;-------------------------------------------------------------------------------
MENUE_GSV_ANZEIGE:
	LD temp,Z+
	call ASCII_temp
	cpi temp,'*'
	brne MENUE_GSV_ANZEIGE
	LD temp,Z+
	call ASCII_temp
	LD temp,Z+
	call ASCII_temp
ret
;-------------------------------------------------------------------------------
MENUE_GSV_SEARCH_Z_C:
	LD temp,Z
	tst temp
	brne MENUE_GSV_SEARCH_w
	CLC 				; Clear Carry
	ret
;-------------------------------------------------------------------------------
MENUE_GSV_SEARCH_w:
	LD temp,Z+
	cpi temp,'G'
	brne MENUE_GSV_SEARCH_Z_C
	LD temp,Z+
	cpi temp,'S'
	brne MENUE_GSV_SEARCH_Z_C
	LD temp,Z+
	cpi temp,'V'
	brne MENUE_GSV_SEARCH_Z_C
	subi ZL,6
	SEC 				; Set Carry
	ret
;-------------------------------------------------------------------------------
MENUE_GSV_Z:
	LD temp1,Z+
	call ZAHL2_TEMP1	; PRN number(00-99)	
	LD temp1,Z+
	call ZAHL2_TEMP1	; Elevation(00-90)	
	LD temp1,Z+
	LD temp2,Z+
	call ZAHL3_TEMP1_2	;Azimuth(000-359)	
	LD temp1,Z+
	call ZAHL2_TEMP1	;SNR db(00-99)		

	call ASCII_SPACE6

	LD temp1,Z+
	call ZAHL2_TEMP1	; PRN number(00-99)	
	LD temp1,Z+
	call ZAHL2_TEMP1	; Elevation(00-90)	
	LD temp1,Z+
	LD temp2,Z+
	call ZAHL3_TEMP1_2	;Azimuth(000-359)	
	LD temp1,Z+
	call ZAHL2_TEMP1	;SNR db(00-99)		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SEKTOR_VIEW_ASCII:
	call TEXT_SEKTOR
	call GPS_CALC_SD_SEKTOR_C
	call ANZEIGE_SEKTOR_DEZ_KURZ
	call ANZEIGE_GPS_DATUM_KURZ
	call ANZEIGE_GPS_ZEIT_KURZ
	call SD_SEKTOR_READ

	call ZEILE_1
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	call ANZEIGE_ASCII_ZEILE_Z	;  0
	call ANZEIGE_ASCII_ZEILE_Z	;  1
	call ANZEIGE_ASCII_ZEILE_Z	;  2
	call ANZEIGE_ASCII_ZEILE_Z	;  3
	call ANZEIGE_ASCII_ZEILE_Z	;  4
	call ANZEIGE_ASCII_ZEILE_Z	;  5
	call ANZEIGE_ASCII_ZEILE_Z	;  6
	call ANZEIGE_ASCII_ZEILE_Z	;  7
	call ANZEIGE_ASCII_ZEILE_Z	;  8
	call ANZEIGE_ASCII_ZEILE_Z	;  9
	call ANZEIGE_ASCII_ZEILE_Z	; 10
	call ANZEIGE_ASCII_ZEILE_Z	; 11
	call ANZEIGE_ASCII_ZEILE_Z	; 12
	call ANZEIGE_ASCII_ZEILE_Z	; 13
	call ANZEIGE_ASCII_ZEILE_Z	; 14
	call ANZEIGE_ASCII_ZEILE_Z	; 15
	call ANZEIGE_ASCII_ZEILE_Z	; 16
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_PLAY:
	call TEXT_SD
	call TEXT_SEKTOR
	LDS SEKTOR0,(adr_SEKTOR0)
	LDS SEKTOR1,(adr_SEKTOR1)
	LDS SEKTOR2,(adr_SEKTOR2)
	LDS SEKTOR3,(adr_SEKTOR3)

	call ANZEIGE_SEKTOR_DEZ_KURZ

	call ZEILE_1
	call SD_SEKTOR_READ
	ldi ZL,low (adr_SD_DATA)
	ldi ZH,high(adr_SD_DATA)
	call ANZEIGE_ASCII_ZEILE_Z	;  0
	call ANZEIGE_ASCII_ZEILE_Z	;  1
	call ANZEIGE_ASCII_ZEILE_Z	;  2
	call ANZEIGE_ASCII_ZEILE_Z	;  3
	call ANZEIGE_ASCII_ZEILE_Z	;  4
	call ANZEIGE_ASCII_ZEILE_Z	;  5
	call ANZEIGE_ASCII_ZEILE_Z	;  6
	call ANZEIGE_ASCII_ZEILE_Z	;  7
	call ANZEIGE_ASCII_ZEILE_Z	;  8
	call ANZEIGE_ASCII_ZEILE_Z	;  9
	call ANZEIGE_ASCII_ZEILE_Z	; 10
	call ANZEIGE_ASCII_ZEILE_Z	; 11
	call ANZEIGE_ASCII_ZEILE_Z	; 12
	call ANZEIGE_ASCII_ZEILE_Z	; 13
	call ANZEIGE_ASCII_ZEILE_Z	; 14
	call ANZEIGE_ASCII_ZEILE_Z	; 15
	call ANZEIGE_ASCII_ZEILE_Z	; 16

	call SEKTOR_PLUS_EINS
	STS(adr_SEKTOR0),SEKTOR0
	STS(adr_SEKTOR1),SEKTOR1
	STS(adr_SEKTOR2),SEKTOR2
	STS(adr_SEKTOR3),SEKTOR3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_WERKSEINSTELLUNG:
	call TEXT_WERK
	call TASTE_B_CARRY
	brcs MENUE_WERKSEINSTELLUNG_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_WERKSEINSTELLUNG_RUN:
	STS(adr_VERSION),NULL
	call EEPROM_SAVE
	jmp PROGRAMM_NEUSTART
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_TV_KORREKTUR:
	call ASCII_X
	call ASCII_SPACE
	call TEXT_KORREKTUR
	call TASTE_B_CARRY
	brcs MENUE_EDIT_TV_KORREKTUR_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_EDIT_TV_KORREKTUR_RUN:
	call BEEP_LANG
;-------------------------------------------------------------------------------
MENUE_EDIT_TV_KORREKTUR_s:
	call ZEILE_0
	call ASCII_X
	call ASCII_SPACE
	call TEXT_KORREKTUR
	call ZEILE_3
	LDS temp1,(adr_TV_X_KORREKTUR)
	call ZAHL_TEMP1

	LDS temp1,(adr_TV_X_KORREKTUR)
	call DREHGEBER_TEMP1_4
	andi temp1,0b00001111
	tst temp1
	brne MENUE_KORREKTUR_w
	ldi temp1,1
MENUE_KORREKTUR_w:
	STS(adr_TV_X_KORREKTUR),temp1
	call TASTE_CARRY
	brcc MENUE_EDIT_TV_KORREKTUR_s
;-------------------------------------------------------------------------------
	call GRAFIC_CLEAR
	call BEEP_LANG
	call EEPROM_SAVE
	call GRAFIC_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_EDIT_UTC_KORREKTUR:
	call TEXT_EDIT
	call ASCII_SPACE
	call TEXT_UTC
	LDS temp1,(adr_UTC)
	call ZAHL_TEMP1

	call TASTE_B_CARRY
	brcs MENUE_EDIT_UTC_KORREKTUR_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_EDIT_UTC_KORREKTUR_RUN:
	call BEEP_LANG
;-------------------------------------------------------------------------------
MENUE_EDIT_UTC_KORREKTUR_s:
	call ZEILE_3
	LDS temp1,(adr_UTC)
	call ZAHL_TEMP1

	LDS temp1,(adr_UTC)
	call DREHGEBER_TEMP1_4
	andi temp1,0b00001111
	tst temp1
	brne MENUE_EDIT_UTC_KORREKTUR_w
	ldi temp1,1
MENUE_EDIT_UTC_KORREKTUR_w:
	STS(adr_UTC),temp1
	call TASTE_CARRY
	brcc MENUE_EDIT_UTC_KORREKTUR_s
;-------------------------------------------------------------------------------
	call GRAFIC_CLEAR
	call BEEP_LANG
	call EEPROM_SAVE
	call GRAFIC_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ASCII_TEST0:
	STS(adr_GRAFIC_FONT),NULL
	call ZEILE_0
	clr temp9
MENUE_ASCII_TEST0_s:
	mov temp,temp9
	call ASCII_TEMP
	inc temp9
	cpi temp9,127+1
	brne MENUE_ASCII_TEST0_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ASCII_TEST1:
	STS(adr_GRAFIC_FONT),EINS
	call ZEILE_0
	clr temp9
MENUE_ASCII_TEST1_s:
	mov temp,temp9
	call ASCII_TEMP
	inc temp9
	cpi temp9,127+1
	brne MENUE_ASCII_TEST1_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_READ_TEST:
	call TEXT_SD
	call TEXT_READ
	call TEXT_TEST
	call TASTE_B_CARRY
	brcs MENUE_SD_READ_TEST_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_READ_TEST_RUN:
	call GRAFIC_CLEAR
	STS(adr_GRAFIC_FONT),EINS
	call BEEP
;-------------------------------------------------------------------------------
MENUE_SD_READ_TEST_w:
	call ZEILE_0
	call TEXT_SD
	call TEXT_READ
	call ZEILE_3
	call TEXT_WAIT
	call SEKTOR_NULL		; NULL				
;-------------------------------------------------------------------------------
MENUE_SD_READ_TEST_s:
	call ZAHLER_NULL		; NULL				
	LDS temp,(adr_ss)		; Synchronisierung	
	STS(adr_ss_OLD),temp
;-------------------------------------------------------------------------------
MENUE_SD_READ_TEST_s0:
	WDR
	LDS temp1,(adr_ss)
	LDS temp2,(adr_ss_OLD)
	cp temp1,temp2
	breq MENUE_SD_READ_TEST_s0
	LDS temp,(adr_ss)		; Synchronisierung	
	STS(adr_ss_OLD),temp
;-------------------------------------------------------------------------------
MENUE_SD_READ_TEST_s2:
	call SD_SEKTOR_READ
	call SEKTOR_PLUS_EINS
	call ZAHLER_PLUS_EINS
	LDS temp1,(adr_ss)
	LDS temp2,(adr_ss_OLD)
	cp temp1,temp2
	breq MENUE_SD_READ_TEST_s2
;-------------------------------------------------------------------------------
	call ZEILE_3
	call ANZEIGE_ZAEHLER_KURZ
	call TEXT_SEC_PRO_SEC
	call ZEILE_5
	call ANZEIGE_SEKTOR_HEX_KURZ
	call ZEILE_7
	call ANZEIGE_SEKTOR_DEZ_KURZ
	call TASTE_CARRY
	brcc MENUE_SD_READ_TEST_s
;-------------------------------------------------------------------------------
	call GRAFIC_CLEAR
	call BEEP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_SD_LL_FORMATIERUNG:
	call TEXT_SD
	call TEXT_LL
	call TEXT_FORMATIERUNG
	call TASTE_B_CARRY
	brcs MENUE_SD_LL_FORMATIERUNG_RUN
	ret
;-------------------------------------------------------------------------------
MENUE_SD_LL_FORMATIERUNG_RUN:
	call GRAFIC_CLEAR
	call BEEP_LANG
	call TEXT_WAIT
	call SD_DATA_CLEAR	
	call SEKTOR_NULL
	ldi ZL,low (10000)
	ldi ZH,high(10000)
MENUE_SD_LL_FORMATIERUNG_s:
	push ZL
	push ZH
	call ZEILE_6
	call ANZEIGE_SEKTOR_DEZ_KURZ

	STS(adr_SD_DATA+0),SEKTOR3
	STS(adr_SD_DATA+1),SEKTOR2
	STS(adr_SD_DATA+2),SEKTOR1
	STS(adr_SD_DATA+3),SEKTOR0

	call SD_SEKTOR_WRITE
	call SEKTOR_PLUS_EINS
	pop ZH
	pop ZL
	sbiw ZL,1
	tst ZL
	brne MENUE_SD_LL_FORMATIERUNG_s
	tst ZH
	brne MENUE_SD_LL_FORMATIERUNG_s
;-------------------------------------------------------------------------------
	call GRAFIC_CLEAR
	call BEEP_LANG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


